%define __kde4_alternate_placement 1

%def_enable netman
%def_enable google
%def_disable xklavier
%define x11confdir %_sysconfdir/X11

%add_findreq_skiplist %__kde4_bindir/krdb
%add_findreq_skiplist %__kde4_bindir/startkde
%add_findreq_skiplist %_K4apps/plasma_scriptengine_ruby/*.rb


%define major 4
%define minor 2
%define bugfix 4
%define rname kdebase-workspace
Name: kde4base-workspace
Version: %major.%minor.%bugfix
Release: alt6.M50.1

Group: Graphical desktop/KDE
Summary: K Desktop Environment - Workspace
License: GPLv2
Url: http://www.kde.org/

Requires: %name-core = %version-%release
Requires: %name-kdm = %version-%release
#Requires: %name-libs = %version-%release


Source0: ftp://ftp.kde.org/pub/kde/stable/%version/src/%rname-%version.tar
Source1: pam-kde4
Source2: pam-kde4-np
Source3: pam-kde4-kscreensaver
Source4: oxygen_lib.tar
Source5: kdm-settings.tar

# upstream
# RH
Patch21: kdebase-workspace-4.0.72-ck-shutdown.patch
Patch22: kdebase-workspace-4.1.72-plasma-konsole.patch
# SuSE
Patch51: kdm-audit-log.diff
# MDK
Patch101: kdebase-workspace-backports-4.3.0-bluez.patch
# upstream
Patch513: kdebase-workspace-backport-4.3.0-rev909646.patch
Patch514: kdebase-workspace-backport-4.3.0-rev943558.patch
# Ubuntu
Patch800: kubuntu_58_drop_pykde_dep.diff
# ALT
Patch1000: kdebase-workspace-4.2.4-alt-startkde.patch
Patch1001: kdebase-workspace-4.1.0-alt-kdm-confdir.patch
Patch1002: kdebase-workspace-4.0.1-alt-kdm-cmd-poweroff.patch
Patch1003: kdebase-workspace-4.2.4-alt-kdm-defaults.patch
Patch1004: kdebase-workspace-4.0.3-alt-kdm-wmsession.patch
Patch1005: kdebase-workspace-4.0.3-alt-kdm-dont-show-nologin-users.patch
Patch1006: kmenuedit-4.1.2-menueditor.patch
Patch1007: kdebase-workspace-4.1.96-alt-def-kxkb.patch
Patch1008: kdebase-workspace-4.2.0-alt-kdm-defaults-language.patch
Patch1009: kdebase-workspace-4.2.1-alt-kwin-branding.patch
Patch1010: kdebase-workspace-4.2.1-alt-defaults-dpms.patch
Patch1011: kdebase-workspace-4.2.1-alt-add-acc-menuentry.patch
Patch1012: kdebase-workspace-4.2.2-alt-kdm-greet.patch
Patch1013: kdebase-workspace-4.2.2-alt-no-xklavier.patch
Patch1014: kdebase-workspace-4.2.4-alt-kdm-kcm-defaults.patch

BuildRequires(pre): kde4libs-devel rpm-build-python
%if_enabled google
BuildRequires(pre): google-gadgets-devel
%endif
%if_enabled netman
BuildRequires: NetworkManager-devel
%endif
BuildRequires: bzlib-devel gcc-c++
BuildRequires: xorg-x11-devel libbluez4-devel libkrb5-devel libpam-devel libaudit-devel
BuildRequires: libqimageblitz-devel libraw1394-devel libsensors-devel
BuildRequires: libstrigi-devel libusb-compat-devel xml-utils libConsoleKit-devel
BuildRequires: libalternatives-devel libqedje-devel libeet-devel libqzion-devel
%if_enabled xklavier
BuildRequires: libxklavier-devel
%endif
BuildRequires: python-module-sip python-devel
#BuildRequires: libdbus-devel
#BuildRequires: glib2-devel
BuildRequires: kde4libs-devel >= %version

%description
The KDE Workspace consists of what is the desktop of the
KDE Desktop Environment.

This package contains:
* kdm (the login manager of KDE)
* khotkeys (a hotkey daemon)
* klipper (a cut & paste history utility)
* kmenuedit (the menu editor)
* krandrtray (resize and rotate X screens)
* krunner (a command run interface)
* ksysguard (a performance monitor)
* kwin (the window manager of KDE)
* kxkb (a utility to switch keyboard maps)
* plasma (the KDE desktop, panels and widgets workspace application)
* systemsettings (the configuration editor)

%package devel
Group: Development/KDE and QT
Summary: Development files for %name
Requires: %name-common = %version-%release
#Requires: %name = %version-%release
Requires: kde4libs-devel libqimageblitz-devel
%description devel
Development files for %name

%package common
Summary: Common files for %name package
Group: Graphical desktop/KDE
Requires: kde-common >= %major.%minor
#
%description common
Common files for %name package

%package core
Summary: Core files for %name package
Group: Graphical desktop/KDE
Requires: design-graphics >= 4.0.1-alt1
Requires: %name-common = %version-%release
%ifdef __kde4_alternate_placement
%else
Provides: kdebase-wm = %version-%release
Obsoletes: kdebase-wm < %version-%release
%endif
Requires: %{get_dep kde4libs}
Requires: kde4base-runtime >= %version
Requires: kde-icon-theme-oxygen
Requires: dbus-tools-gui
%if_enabled google
Requires: %{get_dep libgoogle-gadgets-qt}
Requires: google-gadgets-qt
%endif
%description core
Core files for %name package

%package kdm
Summary: KDE Display Manager (KDM)
Group: System/Libraries
PreReq(post,preun): alternatives >= 0.2
Requires: design-graphics >= 4.0
Requires: %{get_dep kde4libs}
Requires: %name-common = %version-%release
Provides: kde4base-kdm = %version-%release
%ifdef __kde4_alternate_placement
Conflicts: kdebase-kdm <= 3.5.9-alt6
%else
Obsoletes: kdebase-kdm < %version-%release
%endif
%description kdm
This is the KDE Display Manager (KDM), a replacement for the
X Display Manager (XDM)

%package libs
Summary: Runtime libraries for %name
Group: System/Libraries
Requires: %{get_dep kde4libs}
Requires: %name-common = %version-%release
%description libs
Runtime libraries for %name

%prep
%setup -q -n %rname-%version -a4
cp -ar oxygen_lib kwin/clients/oxygen/lib
cp -ar oxygen_lib kwin/clients/ozone/lib
%if_disabled google
rm -rf plasma/scriptengines/google_gadgets
%endif
%patch21 -p1
%patch22 -p1
%patch51 -p0
#
%patch101 -p1
#
%patch513 -p1
%patch514 -p0
#
%patch800 -p1
#
%patch1000 -p1 -b .startkde
%patch1001 -p1
%patch1002 -p1
%patch1003 -p1 -b .kdmdefs
%patch1004 -p1
%patch1005 -p1
%patch1006 -p1
%patch1007 -p1
%patch1008 -p1
%patch1009 -p1
%patch1010 -p1
%patch1011 -p1
%patch1012 -p1
%patch1013 -p1
%patch1014 -p1


%build
%K4cmake \
%if_disabled netman
    -DWITH_NetworkManager=off \
%endif
    -DKDE4_COMMON_PAM_SERVICE=kde4 \
    -DKDE4_KDM_PAM_SERVICE=kde4 \
    -DKDE4_KCHECKPASS_PAM_SERVICE=kde4 \
    -DKDM_CONFIG_INSTALL_DIR=%x11confdir/kdm4 \
    -DKDE4_KSCREENSAVER_PAM_SERVICE=kde4-kscreensaver \
%if_enabled xklavier
    -DUSE_XKLAVIER:BOOL=ON \
%else
    -DUSE_XKLAVIER:BOOL=OFF \
%endif
    -DKDE_DEFAULT_HOME:STRING=".kde4"
%K4make

%install
export GENKDMCONF_FLAGS="--no-old"
%K4install
mkdir -p %buildroot/%_bindir/

# Install kde pam configuration files
install -d -m 0755 %buildroot/%_sysconfdir/pam.d/
install -m 0644 %SOURCE1 %buildroot/%_sysconfdir/pam.d/kde4
install -m 0644 %SOURCE2 %buildroot/%_sysconfdir/pam.d/kde4-np
install -m 0644 %SOURCE3 %buildroot/%_sysconfdir/pam.d/kde4-kscreensaver

# Add chksession support
mkdir -p %buildroot/%x11confdir/wmsession.d/
%ifdef __kde4_alternate_placement
cat <<__EOF__ > %buildroot/%x11confdir/wmsession.d/99KDE
NAME=KDE4
DESC=The K Desktop Environment
ICON=%_K4iconsdir/oxygen/64x64/apps/kde.png
EXEC=%__kde4_bindir/startkde
SCRIPT:
exec %__kde4_bindir/startkde
%else
cat <<__EOF__ > %buildroot/%x11confdir/wmsession.d/01KDE
NAME=KDE
DESC=The K Desktop Environment
ICON=%_K4iconsdir/oxigen/64x64/apps/kde.png
EXEC=%_K4bindir/startkde
SCRIPT:
exec %_K4bindir/startkde
%endif
__EOF__

# Create menu session
mkdir -p %buildroot/%_menudir/
cat <<__EOF__ > %buildroot/%_menudir/kde4-session
?package(%name): needs=wm \
%ifdef __kde4_alternate_placement
                        section="Session/Windowmanagers" \
			title="KDE4" \
			longtitle="K Desktop Environment" \
			command="%__kde4_bindir/startkde" \
			icon="kde.png"
%else
                        section="Session/Windowmanagers" \
			title="KDE" \
			longtitle="K Desktop Environment" \
			command="%_bindir/startkde" \
			icon="kde.png"
%endif
__EOF__

# install kdm settings
mkdir -p %buildroot/%x11confdir/kdm4
pushd %buildroot/%x11confdir/kdm4
tar xvf %SOURCE5 --strip-components 1
popd
install -m 0644 %buildroot/%_K4conf/kdm/kdmrc %buildroot/%x11confdir/kdm4/
mkdir -p %buildroot/%_localstatedir/kdm4/faces

mkdir -p %buildroot/%_sysconfdir/alternatives/packages.d/
# install kdm alternatives
%ifdef __kde4_alternate_placement
mv %buildroot/%__kde4_bindir/kdm %buildroot/%_K4exec/kdm
mv %buildroot/%__kde4_bindir/kdmctl %buildroot/%_K4exec/kdmctl
%else
mv %buildroot/%_K4bindir/kdm %buildroot/%_K4exec/kdm
mv %buildroot/%_K4bindir/kdmctl %buildroot/%_K4exec/kdmctl
%endif
cat > %buildroot/%_sysconfdir/alternatives/packages.d/kde4-kdm <<__EOF__
%_bindir/kdm	%_K4exec/kdm	20
%_bindir/kdm_config	%_K4exec/kdm_config	%_K4exec/kdm
%_bindir/kdmctl	%_K4exec/kdmctl	%_K4exec/kdm
__EOF__

mkdir -p %buildroot/%_K4xdg_apps/
install -m 0644 %buildroot/%_K4srv/kdm.desktop %buildroot/%_K4xdg_apps/kdm.desktop
sed -i 's|^Type=.*$|Type=Application|' %buildroot/%_K4xdg_apps/kdm.desktop
sed -i 's|^Categories=.*$|Categories=Qt;KDE;System;|' %buildroot/%_K4xdg_apps/kdm.desktop


%post kdm
if [ -d %_localstatedir/kdm4/faces -a ! -e %_localstatedir/kdm4/faces/.default.face.icon -a -f %_datadir/design/current/faces/default.png ]
then
    %__cp -af %_datadir/design/current/faces/default.png %_localstatedir/kdm4/faces/.default.face.icon ||:
fi


%files
%files common
%config(noreplace) %_sysconfdir/pam.d/kde4
%config(noreplace) %_sysconfdir/pam.d/kde4-np

%files kdm
%dir %x11confdir/kdm4
%config(noreplace) %x11confdir/kdm4/*
%config %_sysconfdir/alternatives/packages.d/kde4-kdm
%__kde4_bindir/genkdmconf
%_K4exec/kdm
%_K4exec/kdm_config
%_K4exec/kdmctl
%_K4exec/krootimage
%_K4exec/kdm_greet
%_K4lib/kgreet_*.so*
%_K4apps/kdm/
%exclude %_K4apps/kdm/sessions/*
%__kde4_doc/en/kdm
%_localstatedir/kdm4

%files core
%config(noreplace) %_sysconfdir/pam.d/kde4-kscreensaver
%config(noreplace) %x11confdir/wmsession.d/*KDE
%_menudir/kde4-session
%doc README
%ifdef __kde4_alternate_placement
%else
%config(noreplace) %_sysconfdir/ksysguarddrc
%endif
%config(noreplace) %_sysconfdir/systemsettingsrc
%ifdef __kde4_alternate_placement
%__kde4_bindir/*
%exclude %__kde4_bindir/genkdmconf
%else
%_K4bindir/*
%exclude %_K4bindir/genkdmconf
%endif
%attr(2711,root,chkpwd) %_K4exec/kcheckpass
%_K4exec/kcmdatetimehelper
%_K4exec/kfontprint
%_K4exec/kio_fonts_helper
%_K4exec/krunner_lock
%_K4exec/test_kcm_xinerama
%_K4libdir/libkdeinit4_*.so
%_K4libdir/strigi/*
%_K4conf_bin/*
%_K4lib/*.so*
%exclude %_K4lib/kgreet_*.so*
%_K4apps/*
%exclude %_K4apps/kdm
%exclude %_K4apps/cmake/
%_K4conf/*
%exclude %_K4conf/kdm*
%_K4srv/*
%_K4srvtyp/*
%_K4wall/*
%ifdef __kde4_alternate_placement
%exclude %_K4wall/default_blue*
%endif
%_K4snd/*
%_K4start/*
%__kde4_xdg_apps/*
%_K4xdg_apps/*
#%__kde4_xdg_dirs/*
%_K4cfg/*
%ifdef __kde4_alternate_placement
%__kde4_doc/en/*
%exclude %__kde4_doc/en/kdm
%else
%_K4doc/en/*
%exclude %_K4doc/en/kdm
%endif
%exclude %_K4plug/designer/*
#%_K4datadir/xsessions/*
%_K4dbus_services/*
%_K4iconsdir/oxygen/*/*/*
%ifdef __kde4_alternate_placement
%__kde4_iconsdir/hicolor/*/*/*
%__kde4_iconsdir/Oxygen_*
%else
%_K4_iconsdir/hicolor/*/*/*
%_K4iconsdir/Oxygen_*
%endif
%python_sitelibdir/*

%files libs
%_K4libdir/lib*.so.*

%files devel
%_K4includedir/*
%_K4apps/cmake/
%_K4libdir/cmake/KDE4Workspace-*/
%ifdef __kde4_alternate_placement
%__kde4_libdir_link/lib*.so
%else
%_K4libdir/lib*.so
%endif
%exclude %_K4libdir/libkdeinit4_*.so
%_K4plug/designer/*
%_K4dbus_interfaces/*

%changelog
* Mon Jul 13 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.4-alt6.M50.1
- built for M50

* Fri Jul 10 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.4-alt7
- fix kdm menu entry

* Fri Jul 10 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.4-alt5.M50.1
- built for M50

* Thu Jul 09 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.4-alt6
- add /usr/lib/kde4/bin to PATH
- allow users to setup login icons by default

* Mon Jul 06 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.4-alt5
- kdm settings user faces selection (ALT#20677)
- fix kdm menu entry Categories (ALT#19437)

* Tue Jun 23 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.4-alt4
- rebuilt

* Mon Jun 22 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.4-alt2.M50.1
- built for M50

* Mon Jun 22 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.4-alt3
- rebuilt with new google-gadgets

* Tue Jun 09 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.4-alt2
- add menu entry for kdm setup

* Fri Jun 05 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.4-alt1
- new version

* Mon May 04 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.3-alt1
- new version
- built without libxklavier

* Thu Apr 23 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.2-alt3
- fix to build with libaudit
- fix to start kdm_greet instead of something_greet
- fix build requires

* Fri Apr 17 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.2-alt2
- allow force shutdown to all by default
- add some upstream fixes

* Thu Apr 02 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.2-alt1
- new version

* Fri Mar 27 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.1-alt5
- add pam_loginuid support (fixes #19360)

* Wed Mar 25 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.1-alt4
- built with new Qt

* Mon Mar 23 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.1-alt3
- add upstream fix for quicklaunch applet
- apply default X11 DMPS values to configuration dialog

* Mon Mar 16 2009 Sergey V Turchin <zerg@altlinux.org> 4.2.1-alt2
- built kdm with audit support
- add logo icon to kwin window title by default

* Mon Mar 02 2009 Sergey V Turchin <zerg at altlinux dot org> 4.2.1-alt1
- new version

* Wed Feb 25 2009 Sergey V Turchin <zerg at altlinux dot org> 4.2.0-alt3
- use /etc/sysconfig/i18n for default kdm language

* Thu Feb 05 2009 Sergey V Turchin <zerg at altlinux dot org> 4.2.0-alt2
- built with new bluez
- built python plasma engine

* Wed Jan 28 2009 Sergey V Turchin <zerg at altlinux dot org> 4.2.0-alt1
- new version
- create ~/Desktop at start
- don't insert qt binaries path into PATH variable

* Wed Jan 14 2009 Sergey V Turchin <zerg at altlinux dot org> 4.1.96-alt1
- new version
- removed deprecated macroses from specfile
- show keyboard indicator by default

* Thu Nov 06 2008 Sergey V Turchin <zerg at altlinux dot org> 4.1.3-alt1
- new version

* Thu Oct 09 2008 Sergey V Turchin <zerg at altlinux dot org> 4.1.2-alt1
- new version

* Tue Sep 02 2008 Sergey V Turchin <zerg at altlinux dot org> 4.1.1-alt1
- new version

* Thu Jul 31 2008 Sergey V Turchin <zerg at altlinux dot org> 4.1.0-alt1
- new version

* Wed May 28 2008 Sergey V Turchin <zerg at altlinux dot org> 4.0.80-alt1
- 4.1 beta1

* Tue May 06 2008 Sergey V Turchin <zerg at altlinux dot org> 4.0.72-alt1
- new version

* Fri Apr 18 2008 Sergey V Turchin <zerg at altlinux dot org> 4.0.3-alt3
- add alternatives support for kdm_config and kdmctl
- add symlinks to run kdm greeter on :1 :2 :3 displays

* Wed Apr 09 2008 Sergey V Turchin <zerg at altlinux dot org> 4.0.3-alt2
- update kdm config
- add alternatives support to kdm
- add wmsession support to kdm
- don't show nologin users in kdm

* Tue Apr 01 2008 Sergey V Turchin <zerg at altlinux dot org> 4.0.3-alt1
- new version

* Thu Mar 20 2008 Sergey V Turchin <zerg at altlinux dot org> 4.0.2-alt3
- rebuilt with new libxklavier

* Tue Mar 11 2008 Sergey V Turchin <zerg at altlinux dot org> 4.0.2-alt2
- rebuilt with Qt4 buildkey change

* Fri Mar 07 2008 Sergey V Turchin <zerg at altlinux dot org> 4.0.2-alt1
- new version

* Mon Feb 18 2008 Sergey V Turchin <zerg at altlinux dot org> 4.0.1-alt1
- built for ALT

